import os, sys
import requests
import urllib3
import time
import re
import unicodedata as ud

urllib3.disable_warnings()
pem = os.path.join(os.path.dirname(__file__), 'ShopN.pem')

# 'lp1', 'sp1', 'dd1'
env = 'lp1'
# 'US', 'GB', 'JP', 'AU', 'TW', 'KR'
reg = 'US'
# 'demo', 'titles'
type = 'titles'

start = 70010000000000
end   = 70010000012000 


f = open(os.path.join(os.path.dirname(__file__), 'TID - %s.txt' % reg), 'a')

print('%s - %s:' % (start, end))
found = 0
for id in range(start, end):
    
    if id%100 == 0:
        print('\t%s: found %s in %s tries' % (str(id), str(found), str(id-start)))
    
    url = 'https://bugyo.hac.%s.eshop.nintendo.net/shogun/v1/%s/%s?shop_id=4&lang=en&country=%s' % (env, type, str(id), reg)
    
    r = requests.get(url, cert=pem, verify=False)
    data = r.json()
    
    if data['public_status'] != 'nonpublic':
        found += 1
        try:
            f.write('%s: %s - %s\n' % (data['applications'][0]['id'],
                    data['id'], data['formal_name']))
        except IndexError:
            print('%s has no tid!' % data['id'])
            pass
        except UnicodeEncodeError:
            f.write('%s: %s - %s\n' % (data['applications'][0]['id'], data['id'], 
                    re.sub('[^\x00-\x7f]', '', ud.normalize('NFD', data['formal_name']))))
            pass
                
    time.sleep(0.1)
    
f.close()
print('Found %s in %s tries' % (str(found), str(end-start)))